# APP 基础工程 (uni-app-vue3)

> 项目 Fork 自 [uni-app-vite-ts](https://gitee.com/dcloud/uni-preset-vue/blob/vite-ts)  
> **注意事项**: 运行/调试/编译/发布环境使用 `HBuilderX`, 开发工具统一使用 `Visual Studio Code`

## 开发环境

<!-- prettier-ignore -->
- Visual Studio Code [latest](https://code.visualstudio.com)
- HBuilderX [latest](https://www.dcloud.io/hbuilderx.html)
- 👉 [常用插件清单](./doc/plugins.md)

## 开始

<!-- prettier-ignore -->
- [开发规范说明](./doc/workflow.md)
- [技术栈说明](./doc/technique.md)
- 👉 [参考 hello-uni-app](https://github.com/dcloudio/hello-uniapp), [介绍](https://uniapp.dcloud.net.cn/)

---

## TODO

<!-- prettier-ignore -->
- [x] 项目构建，文档编写
- [x] [commitizen](https://github.com/commitizen/cz-cli), [changelog](https://www.cnblogs.com/mengfangui/p/12634845.html)
- [x] 完善网络请求相关配置
- [x] 集成 [Stomp WebSocket](https://github.com/jmesnil/stomp-websocket)
- [x] 集成 [Pont](https://github.com/alibaba/pont)
- [x] 集成 [Pinia](https://pinia.vuejs.org/)
- [x] 集成 [Vue-i18n](https://github.com/intlify/vue-i18n-next)
- [x] 集成 [UnoCSS](https://github.com/antfu/unocss)
- [x] UI 组件集成 [FirstUI](https://gitlab.yiring.com/open/first-ui), [uni-ui](https://uniapp.dcloud.net.cn/component/uniui/quickstart.html)
- [x] 接入 [消息推送](https://uniapp.dcloud.net.cn/unipush.html)
- [x] 接入 [APP 升级中心](https://uniapp.dcloud.net.cn/uniCloud/upgrade-center.html)
- [ ] ⭐ 参考 [uni-vitesse](https://github.com/Ares-Chang/uni-vitesse) 项目，优化一些配置 [参考更多 uni-helper](https://uni-helper.js.org)
- [ ] 基于 alovajs 请求库改造 Pont 生成的请求代码，并重写请求拦截器、响应拦截器、适配上传下载等功能 [参考](https://alova.js.org/zh-CN/tutorial/request-adapter/alova-adapter-uniapp)
- [ ] 老年人模式（字体放大，按钮放大，适配老年人使用），[参考1](https://uniapp.dcloud.net.cn/component/page-meta.html#page-meta) [参考2](https://www.jianshu.com/p/de4f39d59278)
- [ ] 主题切换(暗色主题)，[参考](https://uniapp.dcloud.net.cn/tutorial/darkmode.html#open-darkmode)
- [ ] APP 权限授权控制，解决华为商店审核问题 [参考 - 湖南天气 APP](https://gitlab.yiring.com/hntq/hntq-v5)
